/* DeforaOS/Apps/Devel/src/asm/test/yasep.S
   Copyright (c) 2011 Pierre Pronchery <khorben@defora.org>
   Copyright (c) 2011-2012 Yann Guidon <whygee@f-cpu.org>
   This file is part of DeforaOS Devel asm

   Assembly language dump to test the Defora
    assembler for the YASEP architecture.
   Bytes are in little endian order.


   Généré le Sun, 23 Sep 2012 16:13:33 GMT
   par http://127.0.0.1/~yg/index.dev.html
      yasep/defora/gen_asm.js version 2012/09/23-dev
 */

.text
/* 0x14 = ADD : Addition*/
	add r1 a5               /* FORM_RR     0x14 0x17               */
	add r1 a5 lsb0 r1       /* FORM_RR     0x17 0x17 0xA0 0x17     */
	add 3 r4                /* FORM_iR     0x16 0x34               */
	add 3 r4 eq             /* FORM_iR     0x17 0x34 0xC2 0x04     */
	add 6309 r1 a3          /* FORM_IRR    0x15 0xB1 0xA5 0x18     */
	add 26195 a4            /* FORM_IR     0x15 0x99 0x53 0x66     */
	add a1 a5 r4            /* FORM_RRR    0x17 0xF7 0x00 0x04     */
	add a1 a5 r4 neq        /* FORM_RRR    0x17 0xF7 0xE0 0x04     */
	add 3 a2 d2             /* FORM_iRR    0x17 0x3D 0x02 0x0C     */
	add 3 a2 d2 eq          /* FORM_iRR    0x17 0x3D 0xC2 0x0C     */

/* 0x10 = AND : Boolean AND*/
	and a3 r5               /* FORM_RR     0x10 0xB5               */
	and a3 r5 carry         /* FORM_RR     0x13 0xB5 0x80 0x05     */
	and 6 a3                /* FORM_iR     0x12 0x6B               */
	and 6 a3 msb1 d5        /* FORM_iR     0x13 0x6B 0xC2 0x6B     */
	and 25917 r1 r2         /* FORM_IRR    0x11 0x21 0x3D 0x65     */
	and 32255 r2            /* FORM_IR     0x11 0x22 0xFF 0x7D     */
	and r4 r3 r1            /* FORM_RRR    0x13 0x43 0x00 0x01     */
	and r4 r3 r1 carry      /* FORM_RRR    0x13 0x43 0x80 0x01     */
	and 2 r1 d2             /* FORM_iRR    0x13 0x21 0x02 0x0C     */
	and 2 r1 d2 never       /* FORM_iRR    0x13 0x21 0x22 0x0C     */

/* 0x30 = ANDN : Boolean AND with one negated input*/
	andn d5 d4              /* FORM_RR     0x30 0x68               */
	andn d5 d4 zero r4      /* FORM_RR     0x33 0x68 0x00 0x48     */
	andn 6 d2               /* FORM_iR     0x32 0x6C               */
	andn 6 d2 eq            /* FORM_iR     0x33 0x6C 0xC2 0x0C     */
	andn 8517 d1 d4         /* FORM_IRR    0x31 0x8E 0x45 0x21     */
	andn 29790 a1           /* FORM_IR     0x31 0xFF 0x5E 0x74     */
	andn r5 a5 a1           /* FORM_RRR    0x33 0x57 0x00 0x0F     */
	andn r5 a5 a1 nz d3     /* FORM_RRR    0x33 0x57 0x20 0xAF     */
	andn 2 d1 a2            /* FORM_iRR    0x33 0x2E 0x02 0x0D     */
	andn 2 d1 a2 bit1 0     /* FORM_iRR    0x33 0x2E 0x42 0x0D     */

/* 0xC0 = CALL : Jump to SI4/IMM16/IMM20 (R/I/i) and write the NPC to SND*/
	call a4 r1              /* FORM_RR     0xC0 0x91               */
	call a4 r1 lsb0 d2      /* FORM_RR     0xC3 0x91 0xA0 0xC1     */
	call 5 d1               /* FORM_iR     0xC2 0x5E               */
	call 5 d1 neq           /* FORM_iR     0xC3 0x5E 0xE2 0x0E     */
	call 496653 a1          /* FORM_IR     0xC1 0xF7 0x0D 0x94     */

/* 0xE0 = CALL2 : Jump to SND+(SI4/IMM16) and write the NPC to SND/DST3*/
	call2 18386 d1 d5       /* FORM_IRR    0xE1 0x6E 0xD2 0x47     */
	call2 d5 r1 r2          /* FORM_RRR    0xE3 0x61 0x00 0x02     */
	call2 d5 r1 r2 carry    /* FORM_RRR    0xE3 0x61 0x80 0x02     */
	call2 1 d3 r3           /* FORM_iRR    0xE3 0x1A 0x02 0x03     */
	call2 1 d3 r3 bit1 15   /* FORM_iRR    0xE3 0x1A 0x42 0xF3     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x54 = CMPE (alias to CMPU) : CoMPare for Equality*/
	cmpe d2 pc              /* FORM_RR     0x54 0xC0               */
	cmpe d2 pc carry        /* FORM_RR     0x57 0xC0 0x80 0x00     */
	cmpe 4 d2               /* FORM_iR     0x56 0x4C               */
	cmpe 4 d2 carry         /* FORM_iR     0x57 0x4C 0x82 0x0C     */
	cmpe 11556 d3           /* FORM_IR     0x55 0x0A 0x24 0x2D     */
#endif

/* 0x74 = CMPS : signed substract the 2 operands and set the Carry bit if borrow*/
	cmps d4 r5              /* FORM_RR     0x74 0x85               */
	cmps d4 r5 neq          /* FORM_RR     0x77 0x85 0xE0 0x05     */
	cmps 7 a4               /* FORM_iR     0x76 0x79               */
	cmps 7 a4 bit1 10       /* FORM_iR     0x77 0x79 0x42 0xA9     */
	cmps 14803 a2           /* FORM_IR     0x75 0x0D 0xD3 0x39     */

/* 0x54 = CMPU : unsigned substract the 2 operands and set the Carry bit if borrow*/
	cmpu a3 d4              /* FORM_RR     0x54 0xB8               */
	cmpu a3 d4 bit0 13      /* FORM_RR     0x57 0xB8 0x60 0xD8     */
	cmpu 5 a3               /* FORM_iR     0x56 0x5B               */
	cmpu 5 a3 nz a2         /* FORM_iR     0x57 0x5B 0x22 0xDB     */
	cmpu 21849 pc           /* FORM_IR     0x55 0x00 0x59 0x55     */

/* 0x20 = CRIT : Start a CRITical section: disable IRQs for imm4 instructions*/
	crit 3                  /* FORM_i      0x22 0x30               */

/* 0x68 = ESB : Extract and Sign-extend Byte*/
	esb r4 d2               /* FORM_RR     0x68 0x4C               */
	esb r4 d2 lsb0 d1       /* FORM_RR     0x6B 0x4C 0xA0 0xEC     */

#if defined(ARCH_yasep32)
/* 0xE8 = ESH : Extract and Sign-extend Half-word*/
	esh r2 r5               /* FORM_RR     0xE8 0x25               */
	esh r2 r5 no_carry      /* FORM_RR     0xEB 0x25 0xA0 0x05     */
#endif

/* 0x48 = EZB : Extract and Zero-extend Byte*/
	ezb a5 r2               /* FORM_RR     0x48 0x72               */
	ezb a5 r2 msb1 r5       /* FORM_RR     0x4B 0x72 0xC0 0x52     */

#if defined(ARCH_yasep32)
/* 0xC8 = EZH : Extract and Zero-extend Half-word*/
	ezh r2 a1               /* FORM_RR     0xC8 0x2F               */
	ezh r2 a1 never         /* FORM_RR     0xCB 0x2F 0x20 0x0F     */
#endif

/* 0x40 = GET : Read from the Special Registers space*/
	get r5 a4               /* FORM_RR     0x40 0x59               */
	get r5 a4 lsb0 a4       /* FORM_RR     0x43 0x59 0xA0 0x99     */
	get 6 r1                /* FORM_iR     0x42 0x61               */
	get 6 r1 carry          /* FORM_iR     0x43 0x61 0x82 0x01     */
	get 409388 d3           /* FORM_IR     0x41 0xA6 0x2C 0x3F     */

/* 0x04 = HALT : Stop the core and wait for an interrupt*/
	halt                    /* FORM_ALONE  0x04 0x00               */

/* 0x28 = IB : Insert a byte into a (half)word*/
	ib a1 r5                /* FORM_RR     0x28 0xF5               */
	ib a1 r5 eq             /* FORM_RR     0x2B 0xF5 0xC0 0x05     */
	ib 7 d2                 /* FORM_iR     0x2A 0x7C               */
	ib 7 d2 nz r5           /* FORM_iR     0x2B 0x7C 0x22 0x5C     */
	ib 42 a2                /* FORM_IR     0x29 0xDD 0x2A 0x00     */
	ib r1 r5 a4             /* FORM_RRR    0x2B 0x15 0x00 0x09     */
	ib r1 r5 a4 bit1 4      /* FORM_RRR    0x2B 0x15 0x40 0x49     */
	ib 7 a5 a2              /* FORM_iRR    0x2B 0x77 0x02 0x0D     */
	ib 7 a5 a2 never        /* FORM_iRR    0x2B 0x77 0x22 0x0D     */

#if defined(ARCH_yasep32)
/* 0x88 = IH : Insert the imm16/si4 Half-word*/
	ih d4 a3                /* FORM_RR     0x88 0x8B               */
	ih d4 a3 bit0 11        /* FORM_RR     0x8B 0x8B 0x60 0xBB     */
	ih 4 a2                 /* FORM_iR     0x8A 0x4D               */
	ih 4 a2 zero r5         /* FORM_iR     0x8B 0x4D 0x02 0x5D     */
	ih 16119 r1 a2          /* FORM_IRR    0x89 0xD1 0xF7 0x3E     */
	ih 13008 r3             /* FORM_IR     0x89 0x33 0xD0 0x32     */
	ih a2 r5 d5             /* FORM_RRR    0x8B 0xD5 0x00 0x06     */
	ih a2 r5 d5 msb0 a3     /* FORM_RRR    0x8B 0xD5 0xE0 0xB6     */
	ih 4 r4 r5              /* FORM_iRR    0x8B 0x44 0x02 0x05     */
	ih 4 r4 r5 no_carry     /* FORM_iRR    0x8B 0x44 0xA2 0x05     */
#endif

#if defined(ARCH_yasep32)
/* 0xA8 = IHH : Insert the imm16/si4 Half-word High*/
	ihh a2 r5               /* FORM_RR     0xA8 0xD5               */
	ihh a2 r5 bit1 5        /* FORM_RR     0xAB 0xD5 0x40 0x55     */
	ihh 5 d5                /* FORM_iR     0xAA 0x56               */
	ihh 5 d5 msb0 r2        /* FORM_iR     0xAB 0x56 0xE2 0x26     */
	ihh 14256 d1 a3         /* FORM_IRR    0xA9 0xBE 0xB0 0x37     */
	ihh 11347 r5            /* FORM_IR     0xA9 0x55 0x53 0x2C     */
	ihh a3 d2 d5            /* FORM_RRR    0xAB 0xBC 0x00 0x06     */
	ihh a3 d2 d5 lsb1 a1    /* FORM_RRR    0xAB 0xBC 0x80 0xF6     */
	ihh 3 a5 d3             /* FORM_iRR    0xAB 0x37 0x02 0x0A     */
	ihh 3 a5 d3 lsb1 d3     /* FORM_iRR    0xAB 0x37 0x82 0xAA     */
#endif

/* 0x80 = IN : Read data from I/O on data bus*/
	in a3 a5                /* FORM_RR     0x80 0xB7               */
	in a3 a5 never          /* FORM_RR     0x83 0xB7 0x20 0x07     */
	in d1 6                 /* FORM_Ri     0x82 0x6E               */
	in d1 6 never           /* FORM_Ri     0x83 0x6E 0x22 0x00     */
	in a5 26544             /* FORM_RI     0x81 0x07 0xB0 0x67     */

/* 0xFC = INV : Forbidden (invalid) opcode*/
	inv                     /* FORM_ALONE  0xFC 0x00               */

/* 0x24 = IPC : InterProcess Call*/
	ipc d5 d2               /* FORM_RR     0x24 0x6C               */
	ipc d2 1                /* FORM_Ri     0x26 0x1C               */
	ipc a2 30130            /* FORM_RI     0x25 0x0D 0xB2 0x75     */

/* 0x44 = IPE : InterProcess Entry*/
	ipe d1 r5               /* FORM_RR     0x44 0xE5               */
	ipe r3 2                /* FORM_Ri     0x46 0x23               */
	ipe d5 13469            /* FORM_RI     0x45 0x06 0x9D 0x34     */

/* 0x64 = IPR : InterProcess Return*/
	ipr d4 a5               /* FORM_RR     0x64 0x87               */
	ipr r3 1                /* FORM_Ri     0x66 0x13               */
	ipr r3 28566            /* FORM_RI     0x65 0x03 0x96 0x6F     */

/* 0x78 = LUT8 : XOR source register with LookUp Table's contents (1 byte in, 2 or 4 bytes out)*/
	lut8 r2 d4              /* FORM_RR     0x78 0x28               */
	lut8 r2 d4 eq           /* FORM_RR     0x7B 0x28 0xC0 0x08     */
	lut8 3 d5               /* FORM_iR     0x7A 0x36               */
	lut8 3 d5 lsb0 a1       /* FORM_iR     0x7B 0x36 0xA2 0xF6     */
	lut8 161 a2 d5          /* FORM_IRR    0x79 0x6D 0xA1 0x00     */
	lut8 195 pc             /* FORM_IR     0x79 0x00 0xC3 0x00     */
	lut8 a2 a1 r1           /* FORM_RRR    0x7B 0xDF 0x00 0x01     */
	lut8 a2 a1 r1 msb0 a5   /* FORM_RRR    0x7B 0xDF 0xE0 0x71     */
	lut8 2 d2 d3            /* FORM_iRR    0x7B 0x2C 0x02 0x0A     */
	lut8 2 d2 d3 bit0 6     /* FORM_iRR    0x7B 0x2C 0x62 0x6A     */

/* 0x08 = MOV : Write imm16/imm20/si4 to dest*/
	mov pc d1               /* FORM_RR     0x08 0x0E               */
	mov pc d1 no_carry      /* FORM_RR     0x0B 0x0E 0xA0 0x0E     */
	mov 3 d4                /* FORM_iR     0x0A 0x38               */
	mov 3 d4 zero r3        /* FORM_iR     0x0B 0x38 0x02 0x38     */
	mov 43214 d2            /* FORM_IR     0x09 0xC0 0xCE 0xA8     */

/* 0x38 = MUL8H : Multiply higher byte (unsigned)*/
	mul8h r4 r3             /* FORM_RR     0x38 0x43               */
	mul8h r4 r3 lsb0 r2     /* FORM_RR     0x3B 0x43 0xA0 0x23     */
	mul8h 2 a5              /* FORM_iR     0x3A 0x27               */
	mul8h 2 a5 zero r4      /* FORM_iR     0x3B 0x27 0x02 0x47     */
	mul8h 157 a3 a2         /* FORM_IRR    0x39 0xDB 0x9D 0x00     */
	mul8h 180 r2            /* FORM_IR     0x39 0x22 0xB4 0x00     */
	mul8h d1 d4 a2          /* FORM_RRR    0x3B 0xE8 0x00 0x0D     */
	mul8h d1 d4 a2 msb0 r1  /* FORM_RRR    0x3B 0xE8 0xE0 0x1D     */
	mul8h 1 a1 r1           /* FORM_iRR    0x3B 0x1F 0x02 0x01     */
	mul8h 1 a1 r1 msb1 a3   /* FORM_iRR    0x3B 0x1F 0xC2 0xB1     */

/* 0x18 = MUL8L : Multiply lower byte (unsigned)*/
	mul8l a1 a4             /* FORM_RR     0x18 0xF9               */
	mul8l a1 a4 eq          /* FORM_RR     0x1B 0xF9 0xC0 0x09     */
	mul8l 1 a5              /* FORM_iR     0x1A 0x17               */
	mul8l 1 a5 msb1 r2      /* FORM_iR     0x1B 0x17 0xC2 0x27     */
	mul8l 42 r5 d2          /* FORM_IRR    0x19 0xC5 0x2A 0x00     */
	mul8l 253 d1            /* FORM_IR     0x19 0xEE 0xFD 0x00     */
	mul8l d2 d5 a4          /* FORM_RRR    0x1B 0xC6 0x00 0x09     */
	mul8l d2 d5 a4 no_carry /* FORM_RRR    0x1B 0xC6 0xA0 0x09     */
	mul8l 4 d1 a3           /* FORM_iRR    0x1B 0x4E 0x02 0x0B     */
	mul8l 4 d1 a3 bit1 7    /* FORM_iRR    0x1B 0x4E 0x42 0x7B     */

/* 0x58 = MULI : Initialize one multiply LUT entry*/
	muli a2 a5              /* FORM_RR     0x58 0xD7               */
	muli 1 a3               /* FORM_iR     0x5A 0x1B               */
	muli 24217 a1           /* FORM_IR     0x59 0x0F 0x99 0x5E     */

/* 0x50 = NAND : Boolean AND with negated output*/
	nand a1 r1              /* FORM_RR     0x50 0xF1               */
	nand a1 r1 zero r3      /* FORM_RR     0x53 0xF1 0x00 0x31     */
	nand 1 r1               /* FORM_iR     0x52 0x11               */
	nand 1 r1 bit0 8        /* FORM_iR     0x53 0x11 0x62 0x81     */
	nand 7419 r3 a5         /* FORM_IRR    0x51 0x73 0xFB 0x1C     */
	nand 24547 a2           /* FORM_IR     0x51 0xDD 0xE3 0x5F     */
	nand a2 r5 d2           /* FORM_RRR    0x53 0xD5 0x00 0x0C     */
	nand a2 r5 d2 carry     /* FORM_RRR    0x53 0xD5 0x80 0x0C     */
	nand 6 d4 a1            /* FORM_iRR    0x53 0x68 0x02 0x0F     */
	nand 6 d4 a1 bit0 14    /* FORM_iRR    0x53 0x68 0x62 0xEF     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x34 = NEG (alias to SUB) : arithmetic negation*/
	neg d4                  /* FORM_R      0x36 0x08               */
	neg d4 msb0 a2          /* FORM_R      0x37 0x08 0xE2 0xD8     */
	neg d5 a1               /* FORM_RR     0x37 0x06 0x02 0x0F     */
	neg d5 a1 msb0 a2       /* FORM_RR     0x37 0x06 0xE2 0xDF     */
#endif

/* 0x00 = NOP : Do nothing*/
	nop                     /* FORM_ALONE  0x00 0x00               */

/* 0xB0 = NOR : Boolean OR with negated output*/
	nor d3 a1               /* FORM_RR     0xB0 0xAF               */
	nor d3 a1 carry         /* FORM_RR     0xB3 0xAF 0x80 0x0F     */
	nor 5 d3                /* FORM_iR     0xB2 0x5A               */
	nor 5 d3 no_carry       /* FORM_iR     0xB3 0x5A 0xA2 0x0A     */
	nor 469 d5 r5           /* FORM_IRR    0xB1 0x56 0xD5 0x01     */
	nor 1030 d3             /* FORM_IR     0xB1 0xAA 0x06 0x04     */
	nor d1 a4 a1            /* FORM_RRR    0xB3 0xE9 0x00 0x0F     */
	nor d1 a4 a1 zero r3    /* FORM_RRR    0xB3 0xE9 0x00 0x3F     */
	nor 7 a5 r5             /* FORM_iRR    0xB3 0x77 0x02 0x05     */
	nor 7 a5 r5 bit1 5      /* FORM_iRR    0xB3 0x77 0x42 0x55     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x90 = NOT (alias to ORN) : Boolean negation (alias to ORN)*/
	not r3                  /* FORM_R      0x92 0x03               */
	not r3 bit1 9           /* FORM_R      0x93 0x03 0x42 0x93     */
	not pc r1               /* FORM_RR     0x93 0x00 0x02 0x01     */
	not pc r1 eq            /* FORM_RR     0x93 0x00 0xC2 0x01     */
#endif

/* 0x70 = OR : Boolean OR*/
	or pc r4                /* FORM_RR     0x70 0x04               */
	or pc r4 bit1 6         /* FORM_RR     0x73 0x04 0x40 0x64     */
	or 5 r2                 /* FORM_iR     0x72 0x52               */
	or 5 r2 carry           /* FORM_iR     0x73 0x52 0x82 0x02     */
	or 13115 a5 d5          /* FORM_IRR    0x71 0x67 0x3B 0x33     */
	or 8008 r5              /* FORM_IR     0x71 0x55 0x48 0x1F     */
	or d2 a3 r4             /* FORM_RRR    0x73 0xCB 0x00 0x04     */
	or d2 a3 r4 carry       /* FORM_RRR    0x73 0xCB 0x80 0x04     */
	or 1 r4 a2              /* FORM_iRR    0x73 0x14 0x02 0x0D     */
	or 1 r4 a2 no_carry     /* FORM_iRR    0x73 0x14 0xA2 0x0D     */

/* 0x90 = ORN : Boolean OR with one negated input*/
	orn a3 r1               /* FORM_RR     0x90 0xB1               */
	orn a3 r1 bit1 4        /* FORM_RR     0x93 0xB1 0x40 0x41     */
	orn 1 d5                /* FORM_iR     0x92 0x16               */
	orn 1 d5 lsb1 a3        /* FORM_iR     0x93 0x16 0x82 0xB6     */
	orn 3958 r2 a4          /* FORM_IRR    0x91 0x92 0x76 0x0F     */
	orn 29896 a2            /* FORM_IR     0x91 0xDD 0xC8 0x74     */
	orn r5 a2 d3            /* FORM_RRR    0x93 0x5D 0x00 0x0A     */
	orn r5 a2 d3 zero a4    /* FORM_RRR    0x93 0x5D 0x00 0x9A     */
	orn 2 pc a3             /* FORM_iRR    0x93 0x20 0x02 0x0B     */
	orn 2 pc a3 bit1 12     /* FORM_iRR    0x93 0x20 0x42 0xCB     */

/* 0xA0 = OUT : Send data to I/O on the address bus*/
	out a2 d4               /* FORM_RR     0xA0 0xD8               */
	out d5 5                /* FORM_Ri     0xA2 0x56               */
	out pc 11454            /* FORM_RI     0xA1 0x00 0xBE 0x2C     */

/* 0x60 = PUT : Write to the Special Registers space*/
	put a4 r4               /* FORM_RR     0x60 0x94               */
	put a1 7                /* FORM_Ri     0x62 0x7F               */
	put r5 25283            /* FORM_RI     0x61 0x05 0xC3 0x62     */

/* 0x8C = ROL : ROtate Left*/
	rol r4 r3               /* FORM_RR     0x8C 0x43               */
	rol r4 r3 msb1 a1       /* FORM_RR     0x8F 0x43 0xC0 0xF3     */
	rol 4 d1                /* FORM_iR     0x8E 0x4E               */
	rol 4 d1 lsb1 r5        /* FORM_iR     0x8F 0x4E 0x82 0x5E     */
	rol 30 r4 r1            /* FORM_IRR    0x8D 0x14 0x1E 0x00     */
	rol 29 r2               /* FORM_IR     0x8D 0x22 0x1D 0x00     */
	rol r3 d1 a4            /* FORM_RRR    0x8F 0x3E 0x00 0x09     */
	rol r3 d1 a4 bit0 9     /* FORM_RRR    0x8F 0x3E 0x60 0x99     */
	rol 2 r3 r2             /* FORM_iRR    0x8F 0x23 0x02 0x02     */
	rol 2 r3 r2 lsb0 a3     /* FORM_iRR    0x8F 0x23 0xA2 0xB2     */

/* 0x6C = ROR : ROtate Right*/
	ror r1 a4               /* FORM_RR     0x6C 0x19               */
	ror r1 a4 bit1 4        /* FORM_RR     0x6F 0x19 0x40 0x49     */
	ror 5 r2                /* FORM_iR     0x6E 0x52               */
	ror 5 r2 zero a4        /* FORM_iR     0x6F 0x52 0x02 0x92     */
	ror 17 a3 d5            /* FORM_IRR    0x6D 0x6B 0x11 0x00     */
	ror 26 r2               /* FORM_IR     0x6D 0x22 0x1A 0x00     */
	ror d1 a2 r3            /* FORM_RRR    0x6F 0xED 0x00 0x03     */
	ror d1 a2 r3 bit1 4     /* FORM_RRR    0x6F 0xED 0x40 0x43     */
	ror 2 a1 d2             /* FORM_iRR    0x6F 0x2F 0x02 0x0C     */
	ror 2 a1 d2 bit0 0      /* FORM_iRR    0x6F 0x2F 0x62 0x0C     */

/* 0x2C = SAR : Shift Arithmetic Right*/
	sar d3 d2               /* FORM_RR     0x2C 0xAC               */
	sar d3 d2 carry         /* FORM_RR     0x2F 0xAC 0x80 0x0C     */
	sar 1 d3                /* FORM_iR     0x2E 0x1A               */
	sar 1 d3 lsb1 r2        /* FORM_iR     0x2F 0x1A 0x82 0x2A     */
	sar 31 r1 a4            /* FORM_IRR    0x2D 0x91 0x1F 0x00     */
	sar 22 r3               /* FORM_IR     0x2D 0x33 0x16 0x00     */
	sar r2 a5 a2            /* FORM_RRR    0x2F 0x27 0x00 0x0D     */
	sar r2 a5 a2 eq         /* FORM_RRR    0x2F 0x27 0xC0 0x0D     */
	sar 4 r5 r4             /* FORM_iRR    0x2F 0x45 0x02 0x04     */
	sar 4 r5 r4 no_carry    /* FORM_iRR    0x2F 0x45 0xA2 0x04     */

/* 0x4C = SHL : SHift logic Left*/
	shl d1 a5               /* FORM_RR     0x4C 0xE7               */
	shl d1 a5 neq           /* FORM_RR     0x4F 0xE7 0xE0 0x07     */
	shl 2 a1                /* FORM_iR     0x4E 0x2F               */
	shl 2 a1 no_carry       /* FORM_iR     0x4F 0x2F 0xA2 0x0F     */
	shl 31 r2 r4            /* FORM_IRR    0x4D 0x42 0x1F 0x00     */
	shl 27 r2               /* FORM_IR     0x4D 0x22 0x1B 0x00     */
	shl a1 r5 r1            /* FORM_RRR    0x4F 0xF5 0x00 0x01     */
	shl a1 r5 r1 zero r5    /* FORM_RRR    0x4F 0xF5 0x00 0x51     */
	shl 2 d5 d1             /* FORM_iRR    0x4F 0x26 0x02 0x0E     */
	shl 2 d5 d1 lsb0 r1     /* FORM_iRR    0x4F 0x26 0xA2 0x1E     */

/* 0x0C = SHR : SHift logic Right*/
	shr a4 a5               /* FORM_RR     0x0C 0x97               */
	shr a4 a5 nz a3         /* FORM_RR     0x0F 0x97 0x20 0xB7     */
	shr 4 d1                /* FORM_iR     0x0E 0x4E               */
	shr 4 d1 zero r1        /* FORM_iR     0x0F 0x4E 0x02 0x1E     */
	shr 25 d2 a5            /* FORM_IRR    0x0D 0x7C 0x19 0x00     */
	shr 17 pc               /* FORM_IR     0x0D 0x00 0x11 0x00     */
	shr a2 a3 d3            /* FORM_RRR    0x0F 0xDB 0x00 0x0A     */
	shr a2 a3 d3 neq        /* FORM_RRR    0x0F 0xDB 0xE0 0x0A     */
	shr 6 d2 a5             /* FORM_iRR    0x0F 0x6C 0x02 0x07     */
	shr 6 d2 a5 lsb1 r4     /* FORM_iRR    0x0F 0x6C 0x82 0x47     */

/* 0xF4 = SMAX : Set dest to imm16/si4 if snd's value is greater (signed) than imm16/si4*/
	smax a4 d5              /* FORM_RR     0xF4 0x96               */
	smax a4 d5 eq           /* FORM_RR     0xF7 0x96 0xC0 0x06     */
	smax 3 a4               /* FORM_iR     0xF6 0x39               */
	smax 3 a4 msb0 d1       /* FORM_iR     0xF7 0x39 0xE2 0xE9     */
	smax 10427 a2 r5        /* FORM_IRR    0xF5 0x5D 0xBB 0x28     */
	smax 20342 d1           /* FORM_IR     0xF5 0xEE 0x76 0x4F     */
	smax a2 d1 d2           /* FORM_RRR    0xF7 0xDE 0x00 0x0C     */
	smax a2 d1 d2 eq        /* FORM_RRR    0xF7 0xDE 0xC0 0x0C     */
	smax 5 d3 d4            /* FORM_iRR    0xF7 0x5A 0x02 0x08     */
	smax 5 d3 d4 msb0 a1    /* FORM_iRR    0xF7 0x5A 0xE2 0xF8     */

/* 0xD4 = SMIN : Set dest to imm16/si4 if snd's value is less (signed) than imm16/si4*/
	smin d1 d3              /* FORM_RR     0xD4 0xEA               */
	smin d1 d3 neq          /* FORM_RR     0xD7 0xEA 0xE0 0x0A     */
	smin 1 d1               /* FORM_iR     0xD6 0x1E               */
	smin 1 d1 lsb0 d5       /* FORM_iR     0xD7 0x1E 0xA2 0x6E     */
	smin 27224 d1 a4        /* FORM_IRR    0xD5 0x9E 0x58 0x6A     */
	smin 11635 a5           /* FORM_IR     0xD5 0x77 0x73 0x2D     */
	smin d4 r2 d3           /* FORM_RRR    0xD7 0x82 0x00 0x0A     */
	smin d4 r2 d3 zero r5   /* FORM_RRR    0xD7 0x82 0x00 0x5A     */
	smin 4 pc d4            /* FORM_iRR    0xD7 0x40 0x02 0x08     */
	smin 4 pc d4 zero a1    /* FORM_iRR    0xD7 0x40 0x02 0xF8     */

/* 0x34 = SUB : Substraction*/
	sub r1 r2               /* FORM_RR     0x34 0x12               */
	sub r1 r2 bit0 10       /* FORM_RR     0x37 0x12 0x60 0xA2     */
	sub 2 d3                /* FORM_iR     0x36 0x2A               */
	sub 2 d3 no_carry       /* FORM_iR     0x37 0x2A 0xA2 0x0A     */
	sub 25892 a2 a4         /* FORM_IRR    0x35 0x9D 0x24 0x65     */
	sub 13282 r3            /* FORM_IR     0x35 0x33 0xE2 0x33     */
	sub d2 a2 d5            /* FORM_RRR    0x37 0xCD 0x00 0x06     */
	sub d2 a2 d5 eq         /* FORM_RRR    0x37 0xCD 0xC0 0x06     */
	sub 1 a1 a5             /* FORM_iRR    0x37 0x1F 0x02 0x07     */
	sub 1 a1 a5 zero r3     /* FORM_iRR    0x37 0x1F 0x02 0x37     */

/* 0xB4 = UMAX : Set dest to imm16/si4 if snd's value is greater (unsigned) than imm16/si4*/
	umax pc d5              /* FORM_RR     0xB4 0x06               */
	umax pc d5 lsb0 a2      /* FORM_RR     0xB7 0x06 0xA0 0xD6     */
	umax 7 d5               /* FORM_iR     0xB6 0x76               */
	umax 7 d5 msb1 r5       /* FORM_iR     0xB7 0x76 0xC2 0x56     */
	umax 28559 d5 r4        /* FORM_IRR    0xB5 0x46 0x8F 0x6F     */
	umax 31826 r5           /* FORM_IR     0xB5 0x55 0x52 0x7C     */
	umax r4 a1 d4           /* FORM_RRR    0xB7 0x4F 0x00 0x08     */
	umax r4 a1 d4 bit1 13   /* FORM_RRR    0xB7 0x4F 0x40 0xD8     */
	umax 1 r2 d3            /* FORM_iRR    0xB7 0x12 0x02 0x0A     */
	umax 1 r2 d3 bit1 2     /* FORM_iRR    0xB7 0x12 0x42 0x2A     */

/* 0x94 = UMIN : Set dest to imm16/si4 if snd's value is less (unsigned) than imm16/si4*/
	umin d5 d3              /* FORM_RR     0x94 0x6A               */
	umin d5 d3 zero d3      /* FORM_RR     0x97 0x6A 0x00 0xAA     */
	umin 4 d1               /* FORM_iR     0x96 0x4E               */
	umin 4 d1 lsb0 r2       /* FORM_iR     0x97 0x4E 0xA2 0x2E     */
	umin 25375 a1 d4        /* FORM_IRR    0x95 0x8F 0x1F 0x63     */
	umin 10778 r3           /* FORM_IR     0x95 0x33 0x1A 0x2A     */
	umin d5 a3 d4           /* FORM_RRR    0x97 0x6B 0x00 0x08     */
	umin d5 a3 d4 no_carry  /* FORM_RRR    0x97 0x6B 0xA0 0x08     */
	umin 4 d2 d5            /* FORM_iRR    0x97 0x4C 0x02 0x06     */
	umin 4 d2 d5 nz r4      /* FORM_iRR    0x97 0x4C 0x22 0x46     */

/* 0xD0 = XOR : Boolean XOR*/
	xor a5 r2               /* FORM_RR     0xD0 0x72               */
	xor a5 r2 never         /* FORM_RR     0xD3 0x72 0x20 0x02     */
	xor 3 a1                /* FORM_iR     0xD2 0x3F               */
	xor 3 a1 lsb0 a2        /* FORM_iR     0xD3 0x3F 0xA2 0xDF     */
	xor 21847 a1 r3         /* FORM_IRR    0xD1 0x3F 0x57 0x55     */
	xor 21091 r3            /* FORM_IR     0xD1 0x33 0x63 0x52     */
	xor r3 a3 a1            /* FORM_RRR    0xD3 0x3B 0x00 0x0F     */
	xor r3 a3 a1 lsb0 r5    /* FORM_RRR    0xD3 0x3B 0xA0 0x5F     */
	xor 3 d5 d2             /* FORM_iRR    0xD3 0x36 0x02 0x0C     */
	xor 3 d5 d2 no_carry    /* FORM_iRR    0xD3 0x36 0xA2 0x0C     */

/* 0xF0 = XORN : Boolean XOR with negated output*/
	xorn d4 r3              /* FORM_RR     0xF0 0x83               */
	xorn d4 r3 msb1 r5      /* FORM_RR     0xF3 0x83 0xC0 0x53     */
	xorn 4 d1               /* FORM_iR     0xF2 0x4E               */
	xorn 4 d1 msb0 r4       /* FORM_iR     0xF3 0x4E 0xE2 0x4E     */
	xorn 17075 a1 r1        /* FORM_IRR    0xF1 0x1F 0xB3 0x42     */
	xorn 12116 d5           /* FORM_IR     0xF1 0x66 0x54 0x2F     */
	xorn r4 d3 a5           /* FORM_RRR    0xF3 0x4A 0x00 0x07     */
	xorn r4 d3 a5 msb1 d2   /* FORM_RRR    0xF3 0x4A 0xC0 0xC7     */
	xorn 6 a2 d5            /* FORM_iRR    0xF3 0x6D 0x02 0x06     */
	xorn 6 a2 d5 lsb1 r5    /* FORM_iRR    0xF3 0x6D 0x82 0x56     */

